-- List and breakdown of spells is taken from PitBull_Aura

local UH = UnderHood
local UHB = UnderHood_Buffs
local BS = LibStub( "LibBabble-Spell-3.0" )
local BSL = BS:GetLookupTable()

local canDispel, friendBuffs, friendDebuffs, selfBuffs, selfDebuffs, petBuffs, petDebuffs, enemyDebuffs
local totalSelfBuffs, totalPetBuffs, totalSelfDebuffs, totalPetDebuffs, allFriendlyBuffs, allFriendlyDebuffs
local _, playerClass = UnitClass( "player" )
local _, playerRace = UnitRace( "player" )

if playerClass == 'PRIEST' then
	canDispel = {
		["Magic"] = true,
		["Disease"] = true,
	}
	selfBuffs = {
		[BSL["Blessed Recovery"]] = true,
		[BSL["Fade"]] = true,
		[BSL["Feedback"]] = playerRace == "Human" or nil,
		[BSL["Focused Casting"]] = true,
		[BSL["Inner Fire"]] = true,
		[BSL["Inner Focus"]] = true,
		[BSL["Levitate"]] = true,
		[BSL["Pain Suppression"]] = true,
		[BSL["Shadowform"]] = true,
		[BSL["Shadowguard"]] = playerRace == "Troll" or nil,
		[BSL["Touch of Weakness"]] = (playerRace == "BloodElf" or playerRace == "Scourge") or nil,
	}
	selfDebuffs = {
		[BSL["Mind Vision"]] = true,
	}
	friendBuffs = {
		[BSL["Abolish Disease"]] = true,
		[BSL["Divine Spirit"]] = true,
		[BSL["Elune's Grace"]] = playerRace == "NightElf" or nil,
		[BSL["Fear Ward"]] = true,
		[BSL["Inspiration"]] = true,
		[BSL["Power Infusion"]] = true,
		[BSL["Power Word: Fortitude"]] = true,
		[BSL["Power Word: Shield"]] = true,
		[BSL["Prayer of Fortitude"]] = true,
		[BSL["Prayer of Mending"]] = true,
		[BSL["Prayer of Shadow Protection"]] = true,
		[BSL["Prayer of Spirit"]] = true,
		[BSL["Renew"]] = true,
		[BSL["Symbol of Hope"]] = playerRace == "Draenei" or nil,
		[BSL["Shadow Protection"]] = true,
	}
	enemyDebuffs = {
		[BSL["Devouring Plague"]] = playerRace == "Scourge" or nil,
		[BSL["Hex of Weakness"]] = playerRace == "Troll" or nil,
		[BSL["Holy Fire"]] = true,
		[BSL["Mind Control"]] = true,
		[BSL["Mind Flay"]] = true,
		[BSL["Mind Soothe"]] = true,
		[BSL["Mind Vision"]] = true,
		[BSL["Psychic Scream"]] = true,
		[BSL["Shackle Undead"]] = true,
		[BSL["Shadow Vulnerability"]] = true,
		[BSL["Silence"]] = true,
		[BSL["Shadow Word: Pain"]] = true,
		[BSL["Starshards"]] = playerRace == "NightElf" or nil,
		[BSL["Touch of Weakness"]] = (playerRace == "BloodElf" or playerRace == "Scourge") or nil,
		[BSL["Vampiric Embrace"]] = true,
		[BSL["Vampiric Touch"]] = true,
	}
	friendDebuffs = {
		[BSL["Weakened Soul"]] = true,
	}
elseif playerClass == 'SHAMAN' then
	canDispel = {
		["Poison"] = true,
		["Disease"] = true,
	}
	selfBuffs = {
		[BSL["Clearcasting"]] = true,
		[BSL["Elemental Devastation"]] = true,
		[BSL["Elemental Mastery"]] = true,
		[BSL["Far Sight"]] = true,
		[BSL["Focused Casting"]] = true,
		[BSL["Ghost Wolf"]] = true,
		[BSL["Lightning Shield"]] = true,
		[BSL["Nature's Swiftness"]] = true,
		[BSL["Sentry Totem"]] = true,
		[BSL["Shamanistic Rage"]] = true,
		[BSL["Water Shield"]] = true,
	}
	friendBuffs = {
		[BSL["Ancestral Fortitude"]] = true,
		[BSL["Bloodlust"]] = (playerRace == "Troll" or playerRace == "Tauren" or playerRace == "Orc") or nil,
		[BSL["Earth Shield"]] = true,
		[BSL["Fire Resistance"]] = true,
		[BSL["Frost Resistance"]] = true,
		[BSL["Grace of Air"]] = true,
		[BSL["Grounding Totem Effect"]] = true,
		[BSL["Healing Stream"]] = true,
		[BSL["Healing Way"]] = true,
		[BSL["Heroism"]] = playerRace == "Draenei" or nil,
		[BSL["Mana Spring"]] = true,
		[BSL["Mana Tide"]] = true,
		[BSL["Nature Resistance"]] = true,
		[BSL["Stoneskin"]] = true,
		[BSL["Strength of Earth"]] = true,
		[BSL["Totem of Wrath"]] = true,
		[BSL["Tranquil Air"]] = true,
		[BSL["Water Breathing"]] = true,
		[BSL["Water Walking"]] = true,
		[BSL["Windwall"]] = true,
		[BSL["Wrath of Air Totem"]] = true,
	}
	enemyDebuffs = {
		[BSL["Earthbind"]] = true,
		[BSL["Flame Shock"]] = true,
		[BSL["Frost Shock"]] = true,
		[BSL["Frostbrand Attack"]] = true,
		[BSL["Stormstrike"]] = true,
		[BSL["Stoneclaw Stun"]] = true,
	}
elseif playerClass == 'PALADIN' then
	canDispel = {
		["Magic"] = true,
		["Poison"] = true,
		["Disease"] = true,
	}
	selfBuffs = {
		[BSL["Avenging Wrath"]] = true,
		[BSL["Divine Favor"]] = true,
		[BSL["Divine Illumination"]] = true,
		[BSL["Divine Protection"]] = true,
		[BSL["Divine Shield"]] = true,
		[BSL["Holy Shield"]] = true,
		[BSL["Righteous Fury"]] = true,
		[BSL["Seal of Blood"]] = playerRace == "BloodElf" or nil,
		[BSL["Seal of Command"]] = true,
		[BSL["Seal of Justice"]] = true,
		[BSL["Seal of Light"]] = true,
		[BSL["Seal of Righteousness"]] = true,
		[BSL["Seal of Vengeance"]] = true,
		[BSL["Seal of Wisdom"]] = true,
		[BSL["Seal of the Crusader"]] = true,
		[BSL["Sense Undead"]] = true,
		[BSL["Summon Charger"]] = true,
		[BSL["Summon Warhorse"]] = true,
		[BSL["Vengeance"]] = true,
	}
	friendBuffs = {
		[BSL["Blessing of Freedom"]] = true,
		[BSL["Blessing of Kings"]] = true,
		[BSL["Blessing of Light"]] = true,
		[BSL["Blessing of Might"]] = true,
		[BSL["Blessing of Protection"]] = true,
		[BSL["Blessing of Sacrifice"]] = true,
		[BSL["Blessing of Salvation"]] = true,
		[BSL["Blessing of Sanctuary"]] = true,
		[BSL["Blessing of Wisdom"]] = true,
		[BSL["Concentration Aura"]] = true,
		[BSL["Crusader Aura"]] = true,
		[BSL["Devotion Aura"]] = true,
		[BSL["Divine Intervention"]] = true,
		[BSL["Fire Resistance Aura"]] = true,
		[BSL["Frost Resistance Aura"]] = true,
		[BSL["Greater Blessing of Kings"]] = true,
		[BSL["Greater Blessing of Light"]] = true,
		[BSL["Greater Blessing of Might"]] = true,
		[BSL["Greater Blessing of Salvation"]] = true,
		[BSL["Greater Blessing of Sanctuary"]] = true,
		[BSL["Greater Blessing of Wisdom"]] = true,
		[BSL["Retribution Aura"]] = true,
		[BSL["Sanctity Aura"]] = true,
		[BSL["Shadow Resistance Aura"]] = true,
	}
	enemyDebuffs = {
		[BSL["Avenger's Shield"]] = true,
		[BSL["Consecration"]] = true,
		[BSL["Hammer of Justice"]] = true,
		[BSL["Holy Vengeance"]] = true,
		[BSL["Judgement of Justice"]] = true,
		[BSL["Judgement of Light"]] = true,
		[BSL["Judgement of Wisdom"]] = true,
		[BSL["Judgement of the Crusader"]] = true,
		[BSL["Repentance"]] = true,
		[BSL["Stun"]] = true, -- from Seal of Justice
		[BSL["Turn Undead"]] = true,
	}
	friendDebuffs = {
		[BSL["Forbearance"]] = true,
	}
elseif playerClass == 'MAGE' then
	canDispel = {
		["Curse"] = true,
	}
	selfBuffs = {
		[BSL["Arcane Power"]] = true,
		[BSL["Blazing Speed"]] = true,
		[BSL["Blink"]] = true,
		[BSL["Clearcasting"]] = true,
		[BSL["Combustion"]] = true,
		[BSL["Evocation"]] = true,
		[BSL["Fire Ward"]] = true,
		[BSL["Frost Armor"]] = true,
		[BSL["Frost Ward"]] = true,
		[BSL["Ice Armor"]] = true,
		[BSL["Ice Barrier"]] = true,
		[BSL["Ice Block"]] = true,
		[BSL["Invisibility"]] = true,
		[BSL["Mage Armor"]] = true,
		[BSL["Mana Shield"]] = true,
		[BSL["Molten Armor"]] = true,
		[BSL["Presence of Mind"]] = true,
		[BSL["Slow Fall"]] = true,
	}
	friendBuffs = {
		[BSL["Amplify Magic"]] = true,
		[BSL["Arcane Brilliance"]] = true,
		[BSL["Arcane Intellect"]] = true,
		[BSL["Dampen Magic"]] = true,
	}
	selfDebuffs = {
		[BSL["Arcane Blast"]] = true,
		[BSL["Hypothermia"]] = true,
	}
	enemyDebuffs = {
		[BSL["Blast Wave"]] = true,
		[BSL["Blizzard"]] = true,
		[BSL["Cone of Cold"]] = true,
		[BSL["Chilled"]] = true,
		[BSL["Detect Magic"]] = true,
		[BSL["Dragon's Breath"]] = true,
		[BSL["Fire Vulnerability"]] = true,
		[BSL["Fireball"]] = true,
		[BSL["Flamestrike"]] = true,
		[BSL["Frost Armor"]] = true,
		[BSL["Frost Nova"]] = true,
		[BSL["Frostbite"]] = true,
		[BSL["Frostbolt"]] = true,
		[BSL["Ice Armor"]] = true,
		[BSL["Ignite"]] = true,
		[BSL["Impact"]] = true,
		[BSL["Polymorph"]] = true,
		[BSL["Polymorph: Pig"]] = true,
		[BSL["Polymorph: Turtle"]] = true,
		[BSL["Pyroblast"]] = true,
		[BSL["Slow"]] = true,
		[BSL["Winter's Chill"]] = true,
	}
elseif playerClass == 'DRUID' then
	canDispel = {
		["Curse"] = true,
		["Poison"] = true,
	}
	selfBuffs = {
		[BSL["Aquatic Form"]] = true,
		[BSL["Barkskin"]] = true,
		[BSL["Bear Form"]] = true,
		[BSL["Cat Form"]] = true,
		[BSL["Clearcasting"]] = true,
		[BSL["Dash"]] = true,
		[BSL["Dire Bear Form"]] = true,
		[BSL["Enrage"]] = true,
		[BSL["Flight Form"]] = true,
		[BSL["Frenzied Regeneration"]] = true,
		[BSL["Moonkin Form"]] = true,
		[BSL["Nature's Grasp"]] = true,
		[BSL["Nature's Swiftness"]] = true,
		[BSL["Omen of Clarity"]] = true,
		[BSL["Prowl"]] = true,
		[BSL["Swift Flight Form"]] = true,
		[BSL["Tiger's Fury"]] = true,
		[BSL["Track Humanoids"]] = true,
		[BSL["Travel Form"]] = true,
	}
	friendBuffs = {
		[BSL["Abolish Poison"]] = true,
		[BSL["Gift of the Wild"]] = true,
		[BSL["Innervate"]] = true,
		[BSL["Leader of the Pack"]] = true,
		[BSL["Lifebloom"]] = true,
		[BSL["Mark of the Wild"]] = true,
		[BSL["Moonkin Aura"]] = true,
		[BSL["Regrowth"]] = true,
		[BSL["Rejuvenation"]] = true,
		[BSL["Thorns"]] = true,
		[BSL["Tranquility"]] = true,
		[BSL["Tree of Life"]] = true,
	}
	enemyDebuffs = {
		[BSL["Bash"]] = true,
		[BSL["Challenging Roar"]] = true,
		[BSL["Cyclone"]] = true,
		[BSL["Demoralizing Roar"]] = true,
		[BSL["Entangling Roots"]] = true,
		[BSL["Faerie Fire"]] = true,
		[BSL["Faerie Fire (Feral)"]] = true,
		[BSL["Feral Charge"]] = true,
		[BSL["Hibernate"]] = true,
		[BSL["Hurricane"]] = true,
		[BSL["Insect Swarm"]] = true,
		[BSL["Lacerate"]] = true,
		[BSL["Maim"]] = true,
		[BSL["Mangle (Bear)"]] = true,
		[BSL["Mangle (Cat)"]] = true,
		[BSL["Moonfire"]] = true,
		[BSL["Pounce"]] = true,
		[BSL["Rake"]] = true,
		[BSL["Rip"]] = true,
		[BSL["Soothe Animal"]] = true,
	}
elseif playerClass == 'WARRIOR' then
	selfBuffs = {
		-- Trainer Skill
		[BSL["Bloodrage"]] = true,
		[BSL["Berserker Rage"]] = true,
		[BSL["Retaliation"]] = true,
		[BSL["Shield Wall"]] = true,
		[BSL["Recklessness"]] = true,
		[BSL["Spell Reflection"]] = true,
		[BSL["Shield Block"]] = true,
		-- Talents: Arms
		[BSL["Sweeping Strikes"]] = true,
		[BSL["Second Wind"]] = true,
		-- Talents: Fury
		[BSL["Bloodthirst"]] = true,
		[BSL["Rampage"]] = true,
		[BSL["Blood Craze"]] = true,
		[BSL["Flurry"]] = true,
		[BSL["Enrage"]] = true,
		-- Talents: Prot
		[BSL["Last Stand"]] = true,
		-- T4, Tank, 2/4 piece bonus
		[BSL["Blade Turning"]] = true,
		[BSL["Revenge"]] = true,
		-- T5, Tank, 2/4 piece bonus
		[BSL["Battle Rush"]] = true,
		[BSL["Reinforced Shield"]] = true,
		-- T5, DPS, 2 piece bonus
		[BSL["Overpower"]] = true,
	}
	selfDebuffs = {
		-- Talents: Fury
		[BSL["Death Wish"]] = true,
	}
	friendBuffs = {
		-- Trainer
		[BSL["Battle Shout"]] = true,
		[BSL["Commanding Shout"]] = true,
		[BSL["Intervene"]] = true,
	}
	enemyDebuffs = {
		-- Trainer Skill
		[BSL["Charge Stun"]] = true,
		[BSL["Hamstring"]] = true,
		[BSL["Thunder Clap"]] = true,
		[BSL["Rend"]] = true,
		[BSL["Mocking Blow"]] = true,
		[BSL["Demoralizing Shout"]] = true,
		[BSL["Intimidating Shout"]] = true,
		[BSL["Intercept Stun"]] = true,
		[BSL["Taunt"]] = true,
		[BSL["Dazed"]] = true,
		[BSL["Disarm"]] = true,
		[BSL["Challenging Shout"]] = true,
		[BSL["Sunder Armor"]] = true,
		-- Talents: Arms
		[BSL["Deep Wound"]] = true,
		[BSL["Improved Hamstring"]] = true,
		[BSL["Mace Stun Effect"]] = true,
		[BSL["Mortal Strike"]] = true,
		[BSL["Blood Frenzy"]] = true,
		-- Talents: Fury
		[BSL["Piercing Howl"]] = true,
		-- Talents: Prot
		[BSL["Shield Bash - Silenced"]] = true,
		[BSL["Revenge Stun"]] = true,
		[BSL["Concussion Blow"]] = true,
	}
elseif playerClass == 'WARLOCK' then
	canDispel = {
		["Magic"] = true,
	}
	selfBuffs = {
		-- Affliction Talents
		[BSL["Amplify Curse"]] = true,
		[BSL["Shadow Trance"]] = true,
		-- Demonology Talents
		[BSL["Master Demonologist"]] = true,
		[BSL["Soul Link"]] = true,
		[BSL["Demonic Knowledge"]] = true,
		[BSL["Demonic Sacrifice"]] = true,
		[BSL["Fel Domination"]] = true,
		-- Destruction Talents
		[BSL["Nether Protection"]] = true,
		[BSL["Backlash"]] = true,
		-- Trainer Skills
		[BSL["Shadow Ward"]] = true,
		[BSL["Demon Armor"]] = true,
		[BSL["Demon Skin"]] = true,
		[BSL["Fel Armor"]] = true,
		[BSL["Sense Demons"]] = true,
		[BSL["Summon Felsteed"]] = true,
		[BSL["Summon Dreadsteed"]] = true,
		-- Pet Abilities
		[BSL["Sacrifice"]] = true,
	}
	friendBuffs = {
		-- Trainer Skills
		[BSL["Soulstone Resurrection"]] = true,
		[BSL["Unending Breath"]] = true,
		[BSL["Detect Invisibility"]] = true,
		-- Pet Abilities
		[BSL["Blood Pact"]] = true, -- Imp
		[BSL["Fire Shield"]] = true, -- Imp
		[BSL["Paranoia"]] = true, -- Felhound
	}
	petBuffs = {
		[BSL["Demonic Frenzy"]] = true, -- Felguard
		[BSL["Well Fed"]] = true, -- Pet snacks (Sporeling snack, Kibler's bits)
	}
	enemyDebuffs = {
		-- Trainer Skills - Affliction
		[BSL["Corruption"]] = true,
		[BSL["Curse of Agony"]] = true,
		[BSL["Curse of Doom"]] = true,
		[BSL["Curse of Recklessness"]] = true,
		[BSL["Curse of Shadow"]] = true,
		[BSL["Curse of Tongues"]] = true,
		[BSL["Curse of Weakness"]] = true,
		[BSL["Curse of the Elements"]] = true,
		[BSL["Death Coil"]] = true,
		[BSL["Fear"]] = true,
		[BSL["Howl of Terror"]] = true,
		[BSL["Drain Life"]] = true,
		[BSL["Drain Mana"]] = true,
		[BSL["Drain Soul"]] = true,
		[BSL["Seed of Corruption"]] = true,
		-- Trainer Spells Demonology
		[BSL["Banish"]] = true,
		--Trainer Spells Destruction
		[BSL["Rain of Fire"]] = true,
		[BSL["Hellfire"]] = true,
		[BSL["Immolate"]] = true,
		-- Talents Affliction
		[BSL["Curse of Exhaustion"]] = true,
		[BSL["Siphon Life"]] = true,
		[BSL["Shadow Embrace"]] = true,
		[BSL["Unstable Affliction"]] = true,
		[BSL["Silence"]] = true, -- Unstable Affliction dispel
		-- Talents Destruction
		[BSL["Aftermath"]] = true,
		[BSL["Shadowfury"]] = true,
		[BSL["Pyroclasm"]] = true,
		[BSL["Shadow Vulnerability"]] = true, -- Improved Shadowbolt
		[BSL["Shadowburn"]] = true,
		-- Pet Abilities
		[BSL["Spell Lock"]] = true,  --Felhunter
		[BSL["Tainted Blood"]] = true,  -- Felhunter
		[BSL["Inferno"]] = true,  -- Infernal Stun ??
		[BSL["Cripple"]] = true,  -- Doomguard
		[BSL["Seduction"]] = true, -- Succubus
		[BSL["Soothing Kiss"]] = true, -- Succubus
		[BSL["Suffering"]] = true, -- Voidwalker
	}
elseif playerClass == 'HUNTER' then
	canDispel = {
		["Magic"] = true,
	}
	selfBuffs = {
		[BSL["Aspect of the Beast"]] = true,
		[BSL["Aspect of the Cheetah"]] = true,
		[BSL["Aspect of the Hawk"]] = true,
		[BSL["Aspect of the Monkey"]] = true,
		[BSL["Aspect of the Viper"]] = true,
		[BSL["Deterrence"]] = true,
		[BSL["Eagle Eye"]] = true,
		[BSL["Eyes of the Beast"]] = true,
		[BSL["Feign Death"]] = true,
		[BSL["Master Tactician"]] = true,
		[BSL["Quick Shots"]] = true,
		[BSL["Rapid Fire"]] = true,
		[BSL["Rapid Killing"]] = true,
		[BSL["The Beast Within"]] = true,
	}
	friendBuffs = {
		[BSL["Aspect of the Pack"]] = true,
		[BSL["Aspect of the Wild"]] = true,
		[BSL["Ferocious Inspiration"]] = true,
		[BSL["Misdirection"]] = true,
		[BSL["Spirit Bond"]] = true,
		[BSL["Trueshot Aura"]] = true,
	}
	petBuffs = {
		[BSL["Bestial Wrath"]] = true,
		[BSL["Boar Charge"]] = true,
		[BSL["Feed Pet Effect"]] = true,
		[BSL["Frenzy"]] = true,
		[BSL["Dash"]] = true,
		[BSL["Dive"]] = true,
		[BSL["Furious Howl"]] = true,
		[BSL["Mend Pet"]] = true,
		[BSL["Prowl"]] = true,
		[BSL["Shell Shield"]] = true,
		[BSL["Warp"]] = true,
		[BSL["Well Fed"]] = true, -- Pet snacks (Sporeling snack, Kibler's bits)
	}
	enemyDebuffs = {
		[BSL["Aimed Shot"]] = true,
		[BSL["Beast Lore"]] = true,
		[BSL["Concussive Barrage"]] = true,
		[BSL["Concussive Shot"]] = true,
		[BSL["Counterattack"]] = true,
		[BSL["Entrapment"]] = true,
		[BSL["Explosive Trap Effect"]] = true,
		[BSL["Expose Weakness"]] = true,
		[BSL["Flare"]] = true,
		[BSL["Freezing Trap Effect"]] = true,
		[BSL["Frost Trap Aura"]] = true,
		[BSL["Hunter's Mark"]] = true,
		[BSL["Improved Concussive Shot"]] = true,
		[BSL["Improved Wing Clip"]] = true,
		[BSL["Intimidation"]] = true,
		[BSL["Scare Beast"]] = true,
		[BSL["Serpent Sting"]] = true,
		[BSL["Scatter Shot"]] = true,
		[BSL["Scorpid Sting"]] = true,
		[BSL["Silencing Shot"]] = true,
		[BSL["Tame Beast"]] = true,
		[BSL["Viper Sting"]] = true,
		[BSL["Wing Clip"]] = true,
		[BSL["Wyvern Sting"]] = true,
		--snake trap
		[BSL["Crippling Poison"]] = true,
		[BSL["Deadly Poison"]] = true,
		[BSL["Mind-numbing Poison"]] = true,
		--pets
		[BSL["Boar Charge"]] = true,
		[BSL["Fire Breath"]] = true,
		[BSL["Growl"]] = true,
		[BSL["Poison Spit"]] = true,
		[BSL["Scorpid Poison"]] = true,
		[BSL["Screech"]] = true,
	}
elseif playerClass == 'ROGUE' then
	selfBuffs = {
		[BSL["Stealth"]] = true,
		[BSL["Evasion"]] = true,
		[BSL["Slice and Dice"]] = true,
		[BSL["Sprint"]] = true,
		[BSL["Vanish"]] = true,
		[BSL["Cloak of Shadows"]] = true,
		-- Talents: Assassination
		[BSL["Remorseless"]] = true,
		[BSL["Cold Blood"]] = true,
		[BSL["Find Weakness"]] = true,
		-- Talents: Combat
		[BSL["Blade Flurry"]] = true,
		[BSL["Adrenaline Rush"]] = true,
		-- Talents: Subtlety
		[BSL["Ghostly Strike"]] = true,
		[BSL["Shadowstep"]] = true,
	}
	enemyDebuffs = {
		[BSL["Sap"]] = true,
		[BSL["Gouge"]] = true,
		[BSL["Expose Armor"]] = true,
		[BSL["Garrote"]] = true,
		[BSL["Garrote - Silence"]] = true,
		[BSL["Rupture"]] = true,
		[BSL["Cheap Shot"]] = true,
		[BSL["Kidney Shot"]] = true,
		[BSL["Blind"]] = true,
		[BSL["Deadly Throw"]] = true,
		-- Talents: Combat
		[BSL["Riposte"]] = true,
		[BSL["Kick - Silenced"]] = true,
		[BSL["Mace Stun Effect"]] = true,
		-- Talents: Subtlety
		[BSL["Hemorrhage"]] = true,
		-- Poison
		[BSL["Crippling Poison"]] = true,
		[BSL["Crippling Poison II"]] = true,
		[BSL["Mind-numbing Poison"]] = true,
		[BSL["Mind-numbing Poison II"]] = true,
		[BSL["Mind-numbing Poison III"]] = true,
		[BSL["Deadly Poison"]] = true,
		[BSL["Deadly Poison II"]] = true,
		[BSL["Deadly Poison III"]] = true,
		[BSL["Deadly Poison IV"]] = true,
		[BSL["Deadly Poison V"]] = true,
		[BSL["Deadly Poison VI"]] = true,
		[BSL["Deadly Poison VII"]] = true,
		[BSL["Wound Poison"]] = true,
		[BSL["Wound Poison II"]] = true,
		[BSL["Wound Poison III"]] = true,
		[BSL["Wound Poison IV"]] = true,
		[BSL["Wound Poison V"]] = true,
		-- PVP Gloves
		[BSL["Deadly Interrupt Effect"]] = true,
	}
end
if not canDispel then
	canDispel = {}
end
if not selfBuffs then
	selfBuffs = {}
end
if not selfDebuffs then
	selfDebuffs = {}
end
if not friendBuffs then
	friendBuffs = {}
end
if not enemyDebuffs then
	enemyDebuffs = {}
end
if not friendDebuffs then
	friendDebuffs = {}
end
if not petBuffs then
	petBuffs = {}
end
if not petDebuffs then
	petDebuffs = {}
end
if playerRace == "BloodElf" then
	enemyDebuffs[BSL["Arcane Torrent"]] = true
	selfBuffs[BSL["Mana Tap"]] = true
elseif playerRace == "Troll" then
	selfBuffs[BSL["Berserking"]] = true
elseif playerRace == "Orc" then
	selfBuffs[BSL["Blood Fury"]] = true
	selfDebuffs[BSL["Blood Fury"]] = true
elseif playerRace == "Scourge" then
	selfBuffs[BSL["Cannibalize"]] = true
	selfBuffs[BSL["Will of the Forsaken"]] = true
elseif playerRace == "Tauren" then
	enemyDebuffs[BSL["War Stomp"]] = true
elseif playerRace == "Dwarf" then
	selfBuffs[BSL["Find Treasure"]] = true
	selfBuffs[BSL["Stoneform"]] = true
elseif playerRace == "Draenei" then
	friendBuffs[BSL["Gift of the Naaru"]] = true
elseif playerRace == "Human" then
	selfBuffs[BSL["Perception"]] = true
elseif playerRace == "NightElf" then
	selfBuffs[BSL["Shadowmeld"]] = true
end
if playerRace == "BloodElf" or playerRace == "Troll" or playerRace == "Orc" or playerRace == "Scourge" or playerRace == "Tauren" then
	-- horde
	friendBuffs[BSL["Silverwing Flag"]] = true
else
	-- alliance
	friendBuffs[BSL["Warsong Flag"]] = true
end
friendBuffs[BSL["Netherstorm Flag"]] = true

totalSelfBuffs, totalPetBuffs, totalSelfDebuffs, totalPetDebuffs, allFriendlyBuffs, allFriendlyDebuffs = {}, {}, {}, {}, {}, {}
for k in pairs(selfBuffs) do
	totalSelfBuffs[k] = true
	allFriendlyBuffs[k] = true
end
for k in pairs(selfDebuffs) do
	totalSelfDebuffs[k] = true
	allFriendlyDebuffs[k] = true
end
for k in pairs(petBuffs) do
	totalPetBuffs[k] = true
	allFriendlyBuffs[k] = true
end
for k in pairs(petDebuffs) do
	totalPetDebuffs[k] = true
	allFriendlyDebuffs[k] = true
end
for k in pairs(friendBuffs) do
	totalSelfBuffs[k] = true
	totalPetBuffs[k] = true
	allFriendlyBuffs[k] = true
end
for k in pairs(friendDebuffs) do
	totalSelfDebuffs[k] = true
	totalPetDebuffs[k] = true
	allFriendlyDebuffs[k] = true
end

UHB.Spells = {
	canDispel = canDispel,
	friendBuffs = friendBuffs,
	friendDebuffs = friendDebuffs,
	selfDebuffs = selfDebuffs,
	petBuffs = petBuffs,
	petDebuffs = petDebuffs,
	enemyDebuffs = enemyDebuffs,
	totalSelfBuffs = totalSelfBuffs,
	totalPetBuffs = totalPetBuffs,
	totalSelfDebuffs = totalSelfDebuffs,
	totalPetDebuffs = totalPetDebuffs,
	allFriendlyBuffs = allFriendlyBuffs,
	allFriendlyDebuffs = allFriendlyDebuffs,
}
